# Whenever a player is not sleeping, set the sleepTimer to 0, keeping it locked.
execute as @a[nbt={SleepTimer:0s}] run scoreboard players set @s sleepTimer 0

execute as @a[nbt={SleepTimer:0s},scores={playerHealed=1..}] run tellraw @s ["",{"text":"You are no longer resting. (Healed "},{"score":{"name":"@s","objective":"playerHealed"}},{"text":" HP!)"}]

# If a player is detected as sleeping, make sure their timer is max value
scoreboard players set @a[scores={playerSleeping=1..}] sleepTimer -300
# Then we'll mark this as 0 so we can check it next time, we'll also make sure it can't even be over one.
scoreboard players set @a[scores={playerSleeping=1..}] playerSleeping 0
# And reset this value so it doesn't just get bigger every time.
scoreboard players set @a[nbt={SleepTimer:0s}] playerHealed 0
# And clear this effect, unfortunately making one suspicious stew less cool.
execute as @a[nbt={SleepTimer:0s}] run effect clear @s minecraft:blindness


# If a player has managed to stay asleep (hasn't been kicked out of bed by hunger) we'll let them know it's working
execute as @a[scores={sleepTimer=-200}] run tellraw @s {"text":"You are now resting..."}
execute as @a[scores={sleepTimer=-200}] run effect give @s minecraft:blindness infinite 255 true

# If a players sleepTimer value hits 1, give them some health
effect give @a[scores={sleepTimer=1,playerHunger=10..}] minecraft:regeneration 1 3 true
# We'll mark down how much they got healed for, so we can print it later
scoreboard players add @a[scores={sleepTimer=1,playerHunger=10..}] playerHealed 3
# Then we punish them for daring to defy the laws of nature.
effect give @a[scores={sleepTimer=1,playerHunger=10..}] minecraft:hunger 1 125 true
# And finally, set a timer according to their hunger. As they approach starvation, the healing slows.
scoreboard players set @a[scores={sleepTimer=1,playerHunger=10..11}] sleepTimer -150
scoreboard players set @a[scores={sleepTimer=1,playerHunger=12..14}] sleepTimer -100
scoreboard players set @a[scores={sleepTimer=1,playerHunger=15..18}] sleepTimer -75
scoreboard players set @a[scores={sleepTimer=1,playerHunger=19..}] sleepTimer -50

# If they had less than 10 hunger, they're too hungry to heal, so we'll let them know.
execute as @a[scores={sleepTimer=..-1,playerHealth=..19,playerHunger=..10}] at @s run tp @s ~ ~ ~
execute as @a[scores={sleepTimer=..-1,playerHealth=..19,playerHunger=..10,playerHealed=1..}] run tellraw @s ["",{"text":"You've become too hungry to continue sleeping!","color":"red"},{"text":" (Healed "},{"score":{"name":"@s","objective":"playerHealed"},"color":"red"},{"text":" HP!)"}]
execute as @a[scores={sleepTimer=..-1,playerHealth=..19,playerHunger=..10,playerHealed=0}] run tellraw @s {"text":"You are too hungry to sleep!","color":"red"}
scoreboard players set @a[scores={sleepTimer=..-1,playerHealth=..19,playerHunger=..10}] playerHealed 0

# Notify players that they're fully healed
execute as @a[scores={sleepTimer=..-1,playerHealth=20}] at @s run tp @s ~ ~ ~
execute as @a[scores={sleepTimer=..-1,playerHealth=20,playerHealed=1..}] run tellraw @s ["",{"text":"You feel completely healed and refreshed!","color":"green"},{"text":" (Healed "},{"score":{"name":"@s","objective":"playerHealed"},"color":"red"},{"text":" HP!)"}]
execute as @a[scores={sleepTimer=..-1,playerHealth=20,playerHealed=0}] run tellraw @s ["",{"text":"You are aleady at full health!","color":"green"}]
scoreboard players set @a[scores={sleepTimer=..-1,playerHealth=20}] playerHealed 0

#
effect give @a[tag=!scoresInitialized] instant_damage 1
effect give @a[tag=!scoresInitialized] instant_health 1 100
effect give @a[tag=!scoresInitialized] hunger 1 255
effect give @a[tag=!scoresInitialized] saturation 1 255
tag @a[tag=!scoresInitialized] add scoresInitialized